Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/batching.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/batching.py	(revision 9315)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/batching.py	(revision 9316)
@@ -545,5 +545,5 @@
 
     location_fields = []
-    additional_fields = ['level', 'code', 'credits']
+    additional_fields = ['level', 'code']
     additional_headers = ['level', 'code']
 
@@ -579,6 +579,8 @@
         obj.dcode = entries[0].__parent__.__parent__.code
         obj.title = entries[0].title
-        obj.credits = entries[0].credits
-        obj.passmark = entries[0].passmark
+        if getattr(obj, 'credits', None) is None:
+            obj.credits = entries[0].credits
+        if getattr(obj, 'passmark', None) is None:
+            obj.passmark = entries[0].passmark
         obj.semester = entries[0].semester
         parent[row['code']] = obj
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/browser.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/browser.py	(revision 9315)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/browser.py	(revision 9316)
@@ -1120,5 +1120,5 @@
     label = _('Add course ticket')
     form_fields = grok.AutoFields(ICourseTicketAdd).omit(
-        'score', 'automatic', 'carry_over')
+        'score', 'automatic', 'carry_over', 'credits', 'passmark')
     pnav = 4
 
@@ -1172,5 +1172,5 @@
     grok.name('manage')
     grok.require('waeup.manageStudent')
-    form_fields = grok.AutoFields(ICourseTicket)
+    form_fields = grok.AutoFields(ICourseTicket).omit('credits', 'passmark')
     grok.template('courseticketmanagepage')
     pnav = 4
@@ -2107,5 +2107,5 @@
     grok.require('waeup.handleStudent')
     form_fields = grok.AutoFields(ICourseTicketAdd).omit(
-        'score', 'mandatory', 'automatic', 'carry_over')
+        'score', 'mandatory', 'automatic', 'carry_over', 'credits', 'passmark')
 
     def update(self):
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/export.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/export.py	(revision 9315)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/export.py	(revision 9316)
@@ -210,6 +210,6 @@
     #: Fieldnames considered by this exporter
     fields = tuple(sorted(iface_names(ICourseTicket) +
-        ['level', 'code', 'title', 'credits',
-        'passmark', 'semester', 'fcode', 'dcode'])) + ('student_id', 'certcode')
+        ['level', 'code', 'title',
+        'semester', 'fcode', 'dcode'])) + ('student_id', 'certcode')
 
     #: The title under which this exporter will be displayed
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/interfaces.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/interfaces.py	(revision 9315)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/interfaces.py	(revision 9316)
@@ -512,4 +512,14 @@
         )
 
+    credits = schema.Int(
+        title = _(u'Credits'),
+        required = False,
+        )
+
+    passmark = schema.Int(
+        title = _(u'Passmark'),
+        required = False,
+        )
+
     def getLevel():
         """Returns the id of the level the ticket has been added to.
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/studylevel.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/studylevel.py	(revision 9315)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/studylevel.py	(revision 9316)
@@ -124,6 +124,4 @@
         self.fcode = None
         self.dcode = None
-        self.credits = 0
-        self.passmark = 0
         self.semester = None
         return
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_export.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_export.py	(revision 9315)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_export.py	(revision 9316)
@@ -293,5 +293,5 @@
             'automatic,carry_over,code,credits,dcode,fcode,level,mandatory,'
             'passmark,score,semester,title,student_id,certcode\r\n'
-            '0,0,,0,,,,0,0,0,,,,\r\n'
+            '0,0,,,,,,0,,0,,,,\r\n'
             )
         return