Index: main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/locales/de/LC_MESSAGES/waeup.fceokene.po
===================================================================
--- main/waeup.kwarapoly/trunk/src/waeup/fceokene/locales/de/LC_MESSAGES/waeup.fceokene.po	(revision 9345)
+++ 	(revision )
@@ -1,167 +1,0 @@
-# #############################################################################
-#
-# Copyright (c) 2003-2004 Zope Corporation and Contributors.
-# All Rights Reserved.
-#
-# This software is subject to the provisions of the Zope Public License,
-# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
-# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
-# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
-# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
-# FOR A PARTICULAR PURPOSE.
-#
-# #############################################################################
-msgid ""
-msgstr ""
-"Project-Id-Version: WAeUP.Kofa\n"
-"POT-Creation-Date: Mon Sep  3 12:52:46 2012\n"
-"PO-Revision-Date: 2012-05-16 15:26+0100\n"
-"Last-Translator: Henrik Bettermann <henrik@waeup.org>\n"
-"Language-Team: WAeUP Germany <henrik@waeup.org>\n"
-"Language: de-DE\n"
-"MIME-Version: 1.0\n"
-"Content-Type: text/plain; charset=UTF-8\n"
-"Content-Transfer-Encoding: 8bit\n"
-"Generated-By: zope/app/locales/extract.py\n"
-"X-Poedit-Language: German\n"
-"X-Poedit-Country: GERMANY\n"
-"X-Poedit-SourceCharset: utf-8\n"
-
-#: waeup/fceokene/browser/theming.py:30
-#, fuzzy
-msgid "FCEOkene Theme"
-msgstr "Benutzerdefiniertes Thema 1"
-
-#: waeup/fceokene/interfaces.py:35
-msgid "School Fee (ignored)"
-msgstr "Schulgebühr (wird nicht verwendet)"
-
-#: waeup/fceokene/interfaces.py:41
-msgid "Application Fee (fallback)"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:47
-#, fuzzy
-msgid "Clearance Fee"
-msgstr "Einschreibungsgebühr"
-
-#: waeup/fceokene/interfaces.py:53
-msgid "Booking Fee"
-msgstr "Buchungsgebühr"
-
-#: waeup/fceokene/interfaces.py:61
-#, fuzzy
-msgid "Maintenance Fee (ignored)"
-msgstr "Miete"
-
-#: waeup/fceokene/interfaces.py:67
-msgid "Gown Fee"
-msgstr "Talar-Gebühr"
-
-#: waeup/fceokene/interfaces.py:73
-msgid "Transfer Fee"
-msgstr "Studienfachwechselgebühr"
-
-#: waeup/fceokene/interfaces.py:88
-msgid "Academic Session"
-msgstr "Akademisches Jahr"
-
-#. Default: ""
-#: waeup/fceokene/interswitch/browser.py:103
-msgid "Unsuccessful callback: ${a}"
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:108
-msgid "Callback amount does not match."
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:113
-msgid "Callback transaction id does not match."
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:119
-msgid "Successful callback received"
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:128
-#: waeup/fceokene/interswitch/browser.py:142
-msgid "CollegePAY"
-msgstr "CollegePAY"
-
-#: waeup/fceokene/interswitch/browser.py:156
-#: waeup/fceokene/interswitch/browser.py:164
-#, fuzzy
-msgid "Requery CollegePAY"
-msgstr "CollegePAY"
-
-#: waeup/fceokene/interswitch/browser.py:175
-#: waeup/fceokene/interswitch/browser.py:254
-msgid "Submit data to CollegePAY (Interswitch Payment Gateway)"
-msgstr "Daten an CollegePAY (Interswitch Payment Gateway) senden"
-
-#: waeup/fceokene/interswitch/browser.py:176
-#: waeup/fceokene/interswitch/browser.py:255
-msgid "Submit"
-msgstr "Senden"
-
-#: waeup/fceokene/interswitch/browser.py:186
-#: waeup/fceokene/interswitch/browser.py:264
-msgid "Payment ticket can't be re-send to CollegePAY."
-msgstr "Bewertete Bezahl-Tickets können nicht erneut gesendet werden."
-
-#: waeup/fceokene/interswitch/browser.py:269
-#, fuzzy
-msgid ""
-"Payment ticket can't be send to CollegePAY. Application period has expired."
-msgstr "Bewertete Bezahl-Tickets können nicht erneut gesendet werden."
-
-#: waeup/fceokene/interswitch/browser.py:315
-#: waeup/fceokene/interswitch/browser.py:342
-msgid "This ticket has already been paid."
-msgstr ""
-
-#. Default: ""
-#: waeup/fceokene/interswitch/browser.py:94
-msgid "Invalid callback: ${a}"
-msgstr ""
-
-#: waeup/fceokene/students/interfaces.py:74
-msgid "Payment Level"
-msgstr ""
-
-#: waeup/fceokene/students/utils.py:194
-msgid "Amount could not be determined."
-msgstr "Betrag konnte nicht ermittelt werden."
-
-#: waeup/fceokene/students/utils.py:201
-msgid "This type of payment has already been made."
-msgstr ""
-
-#: waeup/fceokene/students/utils.py:66
-msgid "Session configuration object is not available."
-msgstr "Session-Konfiguration ist nicht verfügbar."
-
-#: waeup/fceokene/students/utils.py:80 waeup/fceokene/students/utils.py:86
-msgid "Study course data are incomplete."
-msgstr ""
-
-#~ msgid "Postgraduates"
-#~ msgstr "Postgraduierte"
-
-#~ msgid "handles postgraduate applicants"
-#~ msgstr "für Antragsteller von Postgraduierten-Studiengängen"
-
-#~ msgid "Surcharge Portal Provider"
-#~ msgstr "Gebühr Portal-Provider"
-
-#~ msgid "Surcharge Interswitch"
-#~ msgstr "Gebühr Interswitch"
-
-#~ msgid "Surcharge 3"
-#~ msgstr "Gebühr 3"
-
-#~ msgid "Acceptance Fee"
-#~ msgstr "Zulassungsgebühr"
-
-#~ msgid "Request CollegePAY callback"
-#~ msgstr "CollegePAY Rückruf"
Index: main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/locales/de/LC_MESSAGES/waeup.kwarapoly.po
===================================================================
--- main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/locales/de/LC_MESSAGES/waeup.kwarapoly.po	(revision 9347)
+++ main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/locales/de/LC_MESSAGES/waeup.kwarapoly.po	(revision 9347)
@@ -0,0 +1,167 @@
+# #############################################################################
+#
+# Copyright (c) 2003-2004 Zope Corporation and Contributors.
+# All Rights Reserved.
+#
+# This software is subject to the provisions of the Zope Public License,
+# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
+# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
+# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
+# FOR A PARTICULAR PURPOSE.
+#
+# #############################################################################
+msgid ""
+msgstr ""
+"Project-Id-Version: WAeUP.Kofa\n"
+"POT-Creation-Date: Mon Sep  3 12:52:46 2012\n"
+"PO-Revision-Date: 2012-10-17 17:48+0100\n"
+"Last-Translator: Henrik Bettermann <henrik@waeup.org>\n"
+"Language-Team: WAeUP Germany <henrik@waeup.org>\n"
+"Language: de-DE\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=UTF-8\n"
+"Content-Transfer-Encoding: 8bit\n"
+"Generated-By: zope/app/locales/extract.py\n"
+"X-Poedit-Language: German\n"
+"X-Poedit-Country: GERMANY\n"
+"X-Poedit-SourceCharset: utf-8\n"
+
+#: waeup/kwarapoly/browser/theming.py:30
+#, fuzzy
+msgid "KwaraPoly Theme"
+msgstr "Benutzerdefiniertes Thema 1"
+
+#: waeup/kwarapoly/interfaces.py:35
+msgid "School Fee (ignored)"
+msgstr "Schulgebühr (wird nicht verwendet)"
+
+#: waeup/kwarapoly/interfaces.py:41
+msgid "Application Fee (fallback)"
+msgstr ""
+
+#: waeup/kwarapoly/interfaces.py:47
+#, fuzzy
+msgid "Clearance Fee"
+msgstr "Einschreibungsgebühr"
+
+#: waeup/kwarapoly/interfaces.py:53
+msgid "Booking Fee"
+msgstr "Buchungsgebühr"
+
+#: waeup/kwarapoly/interfaces.py:61
+#, fuzzy
+msgid "Maintenance Fee (ignored)"
+msgstr "Miete"
+
+#: waeup/kwarapoly/interfaces.py:67
+msgid "Gown Fee"
+msgstr "Talar-Gebühr"
+
+#: waeup/kwarapoly/interfaces.py:73
+msgid "Transfer Fee"
+msgstr "Studienfachwechselgebühr"
+
+#: waeup/kwarapoly/interfaces.py:88
+msgid "Academic Session"
+msgstr "Akademisches Jahr"
+
+#. Default: ""
+#: waeup/kwarapoly/interswitch/browser.py:103
+msgid "Unsuccessful callback: ${a}"
+msgstr ""
+
+#: waeup/kwarapoly/interswitch/browser.py:108
+msgid "Callback amount does not match."
+msgstr ""
+
+#: waeup/kwarapoly/interswitch/browser.py:113
+msgid "Callback transaction id does not match."
+msgstr ""
+
+#: waeup/kwarapoly/interswitch/browser.py:119
+msgid "Successful callback received"
+msgstr ""
+
+#: waeup/kwarapoly/interswitch/browser.py:128
+#: waeup/kwarapoly/interswitch/browser.py:142
+msgid "CollegePAY"
+msgstr "CollegePAY"
+
+#: waeup/kwarapoly/interswitch/browser.py:156
+#: waeup/kwarapoly/interswitch/browser.py:164
+#, fuzzy
+msgid "Requery CollegePAY"
+msgstr "CollegePAY"
+
+#: waeup/kwarapoly/interswitch/browser.py:175
+#: waeup/kwarapoly/interswitch/browser.py:254
+msgid "Submit data to CollegePAY (Interswitch Payment Gateway)"
+msgstr "Daten an CollegePAY (Interswitch Payment Gateway) senden"
+
+#: waeup/kwarapoly/interswitch/browser.py:176
+#: waeup/kwarapoly/interswitch/browser.py:255
+msgid "Submit"
+msgstr "Senden"
+
+#: waeup/kwarapoly/interswitch/browser.py:186
+#: waeup/kwarapoly/interswitch/browser.py:264
+msgid "Payment ticket can't be re-send to CollegePAY."
+msgstr "Bewertete Bezahl-Tickets können nicht erneut gesendet werden."
+
+#: waeup/kwarapoly/interswitch/browser.py:269
+#, fuzzy
+msgid "Payment ticket can't be send to CollegePAY. Application period has expired."
+msgstr "Bewertete Bezahl-Tickets können nicht erneut gesendet werden."
+
+#: waeup/kwarapoly/interswitch/browser.py:315
+#: waeup/kwarapoly/interswitch/browser.py:342
+msgid "This ticket has already been paid."
+msgstr ""
+
+#. Default: ""
+#: waeup/kwarapoly/interswitch/browser.py:94
+msgid "Invalid callback: ${a}"
+msgstr ""
+
+#: waeup/kwarapoly/students/interfaces.py:74
+msgid "Payment Level"
+msgstr ""
+
+#: waeup/kwarapoly/students/utils.py:194
+msgid "Amount could not be determined."
+msgstr "Betrag konnte nicht ermittelt werden."
+
+#: waeup/kwarapoly/students/utils.py:201
+msgid "This type of payment has already been made."
+msgstr ""
+
+#: waeup/kwarapoly/students/utils.py:66
+msgid "Session configuration object is not available."
+msgstr "Session-Konfiguration ist nicht verfügbar."
+
+#: waeup/kwarapoly/students/utils.py:80
+#: waeup/kwarapoly/students/utils.py:86
+msgid "Study course data are incomplete."
+msgstr ""
+
+#~ msgid "Postgraduates"
+#~ msgstr "Postgraduierte"
+
+#~ msgid "handles postgraduate applicants"
+#~ msgstr "für Antragsteller von Postgraduierten-Studiengängen"
+
+#~ msgid "Surcharge Portal Provider"
+#~ msgstr "Gebühr Portal-Provider"
+
+#~ msgid "Surcharge Interswitch"
+#~ msgstr "Gebühr Interswitch"
+
+#~ msgid "Surcharge 3"
+#~ msgstr "Gebühr 3"
+
+#~ msgid "Acceptance Fee"
+#~ msgstr "Zulassungsgebühr"
+
+#~ msgid "Request CollegePAY callback"
+#~ msgstr "CollegePAY Rückruf"