Index: main/waeup.futminna/trunk/src/waeup/futminna/interswitch/browser.py
===================================================================
--- main/waeup.futminna/trunk/src/waeup/futminna/interswitch/browser.py	(revision 9359)
+++ main/waeup.futminna/trunk/src/waeup/futminna/interswitch/browser.py	(revision 9386)
@@ -227,5 +227,5 @@
             if self.context.student.current_mode == 'jm_ft':
                 xmldict['institution_acct'] = "000000000000"
-                xmldict['institution_bank_id'] = '0'
+                xmldict['institution_bank_id'] = '00'
             elif self.context.student.current_mode == 'pg_ft':
                 xmldict['institution_acct'] = "2522040000134"
@@ -265,5 +265,4 @@
             self.pay_item_id = "11706"
 
-        xmldict['institution_item_name'] = self.context.p_category
         xmldict['institution_name'] = INSTITUTION_NAME
         # Interswitch amount is not part of the xml data
@@ -272,5 +271,5 @@
             xmltext = """<payment_item_detail>
 <item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
-<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
+<item_detail item_id="1" item_name="School Fee" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
 <item_detail item_id="2" item_name="%(provider_item_name)s" item_amt="%(provider_amt)d" bank_id="%(provider_bank_id)s" acct_num="%(provider_acct)s" />
 </item_details>
@@ -279,5 +278,5 @@
             xmltext = """<payment_item_detail>
 <item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
-<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
+<item_detail item_id="1" item_name="Acceptance Fee" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
 </item_details>
 </payment_item_detail>""" % xmldict
Index: main/waeup.futminna/trunk/src/waeup/futminna/interswitch/tests.py
===================================================================
--- main/waeup.futminna/trunk/src/waeup/futminna/interswitch/tests.py	(revision 9359)
+++ main/waeup.futminna/trunk/src/waeup/futminna/interswitch/tests.py	(revision 9386)
@@ -50,7 +50,11 @@
         IWorkflowState(self.student).setState('cleared')
         self.browser.open(self.payments_path + '/addop')
+        self.browser.getControl(name="form.p_category").value = ['schoolfee']
         self.browser.getControl("Create ticket").click()
         self.assertMatches('...Payment ticket created...',
                            self.browser.contents)
+
+    def test_interswitch_form(self):
+        # School fee ticket already created in setUp method
         ctrl = self.browser.getControl(name='val_id')
         value = ctrl.options[0]
@@ -63,8 +67,8 @@
         self.payment_url = self.browser.url
 
-    def test_interswitch_form(self):
-
         # Manager can access InterswitchForm
         self.browser.getLink("CollegePAY", index=0).click()
+        # The total amount to be processed by Interswitch
+        # has been reduced by the Interswitch fee of 150 Nairas
         self.assertMatches('...Total Amount Authorized:...',
                            self.browser.contents)
@@ -72,4 +76,42 @@
             '...<input type="hidden" name="amount" value="13150000.0" />...',
             self.browser.contents)
+        self.assertMatches(
+            '...item_name="School Fee" item_amt="12970000" bank_id="89" acct_num="0030001000017110"...',
+            self.browser.contents)
+        self.assertMatches(
+            '...item_name="BT Education" item_amt="150000" bank_id="89" acct_num="0061001000021095"...',
+            self.browser.contents)
+
+        # Create clearance fee ticket
+        self.browser.open(self.payments_path + '/addop')
+        self.browser.getControl(name="form.p_category").value = ['clearance']
+        self.browser.getControl("Create ticket").click()
+        self.assertMatches('...ticket created...',
+                           self.browser.contents)
+        ctrl = self.browser.getControl(name='val_id')
+        value = ctrl.options[1]
+        self.browser.getLink(value).click()
+        self.assertMatches('...Amount Authorized...',
+                           self.browser.contents)
+        self.assertMatches(
+            '...<span>20000.0</span>...',
+            self.browser.contents)
+        # Manager can access InterswitchForm
+        self.browser.getLink("CollegePAY", index=0).click()
+        self.assertMatches('...Total Amount Authorized:...',
+                           self.browser.contents)
+        # The total amount to be processed by Interswitch
+        # has been reduced by the Interswitch fee of 150 Nairas
+        self.assertMatches('...Total Amount Authorized:...',
+                           self.browser.contents)
+        self.assertMatches(
+            '...<input type="hidden" name="amount" value="2000000.0" />...',
+            self.browser.contents)
+        self.assertMatches(
+            '...item_name="Acceptance Fee" item_amt="1970000" bank_id="120" acct_num="1750005063"...',
+            self.browser.contents)
+        # BT does nor charge a fee for clearance
+        self.assertFalse("BT Education" in self.browser.contents)
+
 
     @external_test