Index: main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/interswitch/browser.py
===================================================================
--- main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/interswitch/browser.py	(revision 9386)
+++ main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/interswitch/browser.py	(revision 9387)
@@ -33,8 +33,8 @@
 from waeup.kwarapoly.interfaces import MessageFactory as _
 
-PRODUCT_ID = '83'
+PRODUCT_ID = '3986'
 SITE_NAME = 'kwarapoly-kofa.waeup.org'
-PROVIDER_ACCT = '0026781725'
-PROVIDER_BANK_ID = '31'
+PROVIDER_ACCT = '1010764827'
+PROVIDER_BANK_ID = '117'
 PROVIDER_ITEM_NAME = 'BT Education'
 INSTITUTION_NAME = 'KwaraPoly'
@@ -42,11 +42,11 @@
 #QUERY_URL = 'https://webpay.interswitchng.com/paydirect/services/TransactionQueryURL.aspx'
 #QUERY_URL = 'https://testwebpay.interswitchng.com/test_paydirect/services/TransactionQueryURL.aspx'
-POST_ACTION = 'https://webpay.interswitchng.com/paydirect/webpay/pay.aspx'
-#POST_ACTION = 'https://testwebpay.interswitchng.com/test_paydirect/webpay/pay.aspx'
-
-HOST = 'webpay.interswitchng.com'
-#HOST = 'testwebpay.interswitchng.com'
-URL = '/paydirect/services/TransactionQueryWs.asmx'
-#URL = '/test_paydirect/services/TransactionQueryWs.asmx'
+#POST_ACTION = 'https://webpay.interswitchng.com/paydirect/webpay/pay.aspx'
+POST_ACTION = 'https://testwebpay.interswitchng.com/test_paydirect/webpay/pay.aspx'
+
+#HOST = 'webpay.interswitchng.com'
+HOST = 'testwebpay.interswitchng.com'
+#URL = '/paydirect/services/TransactionQueryWs.asmx'
+URL = '/test_paydirect/services/TransactionQueryWs.asmx'
 httplib.HTTPConnection.debuglevel = 0
 
@@ -178,5 +178,5 @@
     site_name = SITE_NAME
     currency = CURRENCY
-    pay_item_id = '8302'
+    pay_item_id = '101'
     product_id = PRODUCT_ID
 
@@ -209,26 +209,28 @@
         xmldict['provider_bank_id'] = PROVIDER_BANK_ID
         xmldict['provider_item_name'] = PROVIDER_ITEM_NAME
-        xmldict['provider_amt'] = 100 * 500
+        xmldict['provider_amt'] = 100 * 1200
+        # Dalash data
+        xmldict['dalash_amt'] = 100 * 1800
         # Institution data
-        studycourse = student['studycourse']
-        if student.current_mode in ('ug_sw','prence',):
-            xmldict['institution_acct'] = "6216801025"
-            xmldict['institution_bank_id'] = '117'
-        elif student.current_mode in ('ug_ft',) and \
-            student['studycourse'].current_verdict == 'O':
-            xmldict['institution_acct'] = "6216801025"
-            xmldict['institution_bank_id'] = '117'
-        elif student.current_mode in ('ug_ft',):
-            xmldict['institution_acct'] = "6216801033"
-            xmldict['institution_bank_id'] = '117'
-        elif student.current_mode in ('pd_ft',):
-            xmldict['institution_acct'] = "6216801025"
+        if xmldict['faculty'] in ('CPGS',):
+            xmldict['institution_acct'] = "1771180233"
+            xmldict['institution_bank_id'] = '120'
+        elif xmldict['faculty'] in ('IBAS',):
+            xmldict['institution_acct'] = "0006772436"
+            xmldict['institution_bank_id'] = '121'
+        elif xmldict['faculty'] in ('IETS',):
+            xmldict['institution_acct'] = "0106259811"
+            xmldict['institution_bank_id'] = '10'
+        elif xmldict['faculty'] in ('IFMS',):
+            xmldict['institution_acct'] = "2013910271"
+            xmldict['institution_bank_id'] = '8'
+        elif xmldict['faculty'] in ('ITCH',):
+            xmldict['institution_acct'] = "1010445144"
             xmldict['institution_bank_id'] = '117'
         else:
-            xmldict['kwarapoly_acct'] = "0000000000000"
+            xmldict['institution_acct'] = "0000000000000"
             xmldict['institution_bank_id'] = '0'
-        xmldict['kwarapoly_split'] = 100 * 1400
         xmldict['institution_amt'] = 100 * (
-            self.context.amount_auth - 500 - 150 - 1400)
+            self.context.amount_auth - 1200 - 300 - 1800)
         xmldict['institution_item_name'] = self.context.p_category
         xmldict['institution_name'] = INSTITUTION_NAME
@@ -237,5 +239,5 @@
 <item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
 <item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
-<item_detail item_id="2" item_name="KwaraPoly Split" item_amt="%(kwarapoly_split)s" bank_id="117" acct_num="6216801058" />
+<item_detail item_id="2" item_name="Dalash" item_amt="%(dalash_amt)s" bank_id="117" acct_num="1013196791" />
 <item_detail item_id="3" item_name="%(provider_item_name)s" item_amt="%(provider_amt)d" bank_id="%(provider_bank_id)s" acct_num="%(provider_acct)s" />
 </item_details>
@@ -288,6 +290,6 @@
         # Institution data
         xmldict['institution_amt'] = 100 * (self.context.amount_auth - 500 - 150)
-        xmldict['institution_acct'] = '1012445289'
-        xmldict['institution_bank_id'] = '117'
+        xmldict['institution_acct'] = '0'
+        xmldict['institution_bank_id'] = '0'
         xmldict['institution_item_name'] = self.context.p_category
         xmldict['institution_name'] = INSTITUTION_NAME
Index: main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/interswitch/tests.py
===================================================================
--- main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/interswitch/tests.py	(revision 9386)
+++ main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/interswitch/tests.py	(revision 9387)
@@ -16,5 +16,10 @@
 ## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 ##
+import grok
 from hurry.workflow.interfaces import IWorkflowState
+from zope.component import createObject
+from zope.event import notify
+from waeup.kofa.university.faculty import Faculty
+from waeup.kofa.university.department import Department
 from waeup.kofa.students.tests.test_browser import StudentsFullSetup
 from waeup.kofa.applicants.tests.test_browser import ApplicantsFullSetup
@@ -46,4 +51,25 @@
     def setUp(self):
         super(InterswitchTestsStudents, self).setUp()
+
+        # Create at least one Kwarapoly faculty
+        self.app['faculties']['CPGS'] = Faculty(code='CPGS')
+        self.app['faculties']['CPGS']['dep1'] = Department(code='dep1')
+        self.certificate2 = createObject('waeup.Certificate')
+        self.certificate2.code = u'CERT2'
+        self.certificate2.application_category = 'basic'
+        self.certificate2.study_mode = 'nd_ft'
+        self.certificate2.start_level = 100
+        self.certificate2.end_level = 300
+        self.app['faculties']['CPGS']['dep1'].certificates.addCertificate(
+            self.certificate2)
+        # Set study course attributes of test student
+        self.student['studycourse'].certificate = self.certificate2
+        self.student['studycourse'].current_session = 2004
+        self.student['studycourse'].entry_session = 2004
+        self.student['studycourse'].current_verdict = 'A'
+        self.student['studycourse'].current_level = 100
+        # Update the catalog
+        notify(grok.ObjectModifiedEvent(self.student))
+
         self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
         self.browser.open(self.payments_path)
@@ -75,5 +101,5 @@
                            self.browser.contents)
         self.assertMatches(
-            '...<span>12495.0</span>...',
+            '...<span>60980.0</span>...',
             self.browser.contents)
         self.payment_url = self.browser.url
@@ -84,14 +110,14 @@
                            self.browser.contents)
         self.assertMatches(
-            '...<input type="hidden" name="amount" value="1249500.0" />...',
-            self.browser.contents)
-        self.assertMatches(
-            '...item_name="schoolfee" item_amt="1044500" bank_id="117" acct_num="6216801033"...',
-            self.browser.contents)
-        self.assertMatches(
-            '...item_name="KwaraPoly Split" item_amt="140000" bank_id="117" acct_num="6216801058"...',
-            self.browser.contents)
-        self.assertMatches(
-            '...item_name="BT Education" item_amt="50000" bank_id="31" acct_num="0026781725"...',
+            '...<input type="hidden" name="amount" value="6098000.0" />...',
+            self.browser.contents)
+        self.assertMatches(
+            '...item_name="schoolfee" item_amt="5768000" bank_id="120" acct_num="1771180233"...',
+            self.browser.contents)
+        self.assertMatches(
+            '...item_name="Dalash" item_amt="180000" bank_id="117" acct_num="1013196791"...',
+            self.browser.contents)
+        self.assertMatches(
+            '...item_name="BT Education" item_amt="120000" bank_id="117" acct_num="1010764827"...',
             self.browser.contents)
 