Index: main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/students/tests/test_browser.py
===================================================================
--- main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/students/tests/test_browser.py	(revision 9370)
+++ main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/students/tests/test_browser.py	(revision 9388)
@@ -198,5 +198,5 @@
         self.assertEqual(payment.p_level, 100)
         self.assertEqual(payment.p_session, 2004)
-        self.assertEqual(payment.amount_auth, 12495.0)
+        self.assertEqual(payment.amount_auth, 60980.0)
         self.assertEqual(payment.p_item, u'CERT1')
         self.assertEqual(error, None)
@@ -206,5 +206,5 @@
         self.assertEqual(payment.p_level, 200)
         self.assertEqual(payment.p_session, 2005)
-        self.assertEqual(payment.amount_auth, 11545.0)
+        self.assertEqual(payment.amount_auth, 60980.0)
         self.assertEqual(payment.p_item, u'CERT1')
         self.assertEqual(error, None)
Index: main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/students/utils.py
===================================================================
--- main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/students/utils.py	(revision 9370)
+++ main/waeup.kwarapoly/trunk/src/waeup/kwarapoly/students/utils.py	(revision 9388)
@@ -97,113 +97,11 @@
                 return _('Study course data are incomplete.'), None
 
-            # Very special school fee configuration, should be moved to
-            # a seperate file.
 
-            ARTS = ('CRS','ISS','HIS','MUS','ECO','GEO','POL','SOS','CCA','ECU',
-                    'THA','GED','GSE','PES','SPC','ENG','FRE','ARB','HAU','IGB',
-                    'YOR','NCRS','NISS','NHIS','NMUS','NECO','NGEO','NPOL',
-                    'NCCA','NECU','NTHA','NGED','NGSE','NPES','NSPC','NENG',
-                    'NFRE','NARB','NHAU','NIGB','NYOR','NSOS')
-
-            #PDE Students
-            if student.current_mode == 'pd_ft':
-                amount = 35000
-            elif not student.current_mode.endswith('_sw'):
-                # PRENCE
-                if student.current_level == 10 and student.state == CLEARED:
-                    if student.depcode in ARTS:
-                        amount = 14900
-                    else:
-                        amount = 15400
-                # NCE I fresh
-                elif student.current_level == 100 and student.state == CLEARED:
-                    if student.depcode in ARTS:
-                        amount = 12020
-                    else:
-                        amount = 12495
-                # NCE II
-                elif student.current_level in (100, 110, 120) and \
-                    student.state == RETURNING:
-                    if student.depcode in ARTS:
-                        amount = 11070
-                    else:
-                        amount = 11545
-                # NCE III
-                elif student.current_level in (200, 210, 220):
-                    if student.depcode in ARTS:
-                        amount = 11070
-                    else:
-                        amount = 11545
-                # NCE III repeater
-                elif student.current_level in (300, 310, 320) and \
-                    student.current_verdict == 'O':
-                    if student.depcode in ARTS:
-                        amount = 6535
-                    else:
-                        amount = 6773
-                # NCE III spillover
-                elif student.current_level in (300, 310, 320) and \
-                    student.current_verdict == 'B':
-                    if student.depcode in ARTS:
-                        amount = 9170
-                    else:
-                        amount = 9645
-                # NCE III second spillover
-                elif student.current_level in (400, 410, 420) and \
-                    student.current_verdict == 'B':
-                    if student.depcode in ARTS:
-                        amount = 9170
-                    else:
-                        amount = 9645
-            else:
-                if student.current_level == 100 and student.state == CLEARED:
-                    if student.depcode in ARTS:
-                        amount = 21900
-                    else:
-                        amount = 22400
-                # NCE II
-                elif student.current_level in (100, 110, 120) and \
-                    student.state == RETURNING:
-                    if student.depcode in ARTS:
-                        amount = 18400
-                    else:
-                        amount = 18900
-                # NCE III
-                elif student.current_level in (200, 210, 220):
-                    if student.depcode in ARTS:
-                        amount = 20400
-                    else:
-                        amount = 20900
-                # NCE IV
-                elif student.current_level in (300, 310, 320):
-                    if student.depcode in ARTS:
-                        amount = 18400
-                    else:
-                        amount = 18900
-                # NCE V
-                elif student.current_level in (400, 410, 420):
-                    if student.depcode in ARTS:
-                        amount = 18400
-                    else:
-                        amount = 18900
-                # NCE V spillover
-                elif student.current_level in (500, 510, 520) and \
-                    student.current_verdict == 'B':
-                    if student.depcode in ARTS:
-                        amount = 16900
-                    else:
-                        amount = 17400
-                # NCE V second spillover
-                elif student.current_level in (600, 610, 620) and \
-                    student.current_verdict == 'B':
-                    if student.depcode in ARTS:
-                        amount = 16900
-                    else:
-                        amount = 17400
             if student.state == RETURNING:
                 p_session, p_level = self.getReturningData(student)
 
 
-            amount = 0.0
+            if student.state in (RETURNING, CLEARED):
+                amount = 60980.00
 
         if amount in (0.0, None):